#include "main.h"
#include <winsock.h>
#include <time.h>

#define NETWORK_ERROR -1
#define NETWORK_OK     0

MSG_CALLBACK mcb;
HANDLE Thread;
HANDLE SessionMutex;

DWORD WINAPI ThreadProc(LPVOID data)
{
  	WORD sockVersion;
	WSADATA wsaData;
	int nret;

   	char buffer[128];

    while (1)
    {
        OutputDebugStr("tcp status plugin is running");
        sockVersion = MAKEWORD(1, 1);
        // Initialize Winsock
        WSAStartup(sockVersion, &wsaData);
        // Create the socket
        SOCKET theSocket = socket(AF_INET,		// Go over TCP/IP
                   SOCK_STREAM,			// stream-oriented socket
                   IPPROTO_TCP);		// Use TCP

        if (theSocket == INVALID_SOCKET) {
            nret = WSAGetLastError();
            //ReportError(nret, "socket()");
            WSACleanup();
            Sleep(30000);
            continue;
            //return (DWORD)NETWORK_ERROR;
        }
        // Fill a SOCKADDR_IN struct with address information
        SOCKADDR_IN serverInfo;
        serverInfo.sin_family = AF_INET;
        serverInfo.sin_port  = htons(7777);
        serverInfo.sin_addr.s_addr = inet_addr("192.168.2.10");
        // Connect to the server
        nret = connect(theSocket,
                   (LPSOCKADDR)&serverInfo,
                   sizeof(struct sockaddr));

        if (nret == SOCKET_ERROR) {
            nret = WSAGetLastError();
            //ReportError(nret, "connect()");
            OutputDebugStr("connect error");
            WSACleanup();
            Sleep(30000);
            continue;
            //return (DWORD)NETWORK_ERROR;
        }

        // Successfully connected!

        strcpy(buffer, "set status desc ");
        char tmpbuf[65];
        nret = recv(theSocket, tmpbuf,
            64,		// Complete size of buffer
            0);
        for (unsigned int i=0; i<strlen(tmpbuf); i++)
        {
            if(tmpbuf[i]=='\r' || tmpbuf[i]=='\n')
                tmpbuf[i] = ' ';
        }
        if (nret == SOCKET_ERROR)
        {
            //return NETWORK_ERROR;
        }
        else
        {
            // nret contains the number of bytes received
            tmpbuf[nret] = 0;
            strcat(buffer, tmpbuf);
            time_t rawtime;
            struct tm * timeinfo;
            time ( &rawtime );
            timeinfo = localtime ( &rawtime );
            strftime (buffer + strlen(buffer),80,"%H:%M",timeinfo);
            mcb("freegg", buffer);
        }

        // Send/receive, then cleanup:
        closesocket(theSocket);
        WSACleanup();
        Sleep(120000);
    }
    return 0;
}

char* Name()
{
    return "TCP set status plugin";
}

int Load(MSG_CALLBACK callback)
{
    DWORD dwtid;
    mcb = callback;
    Thread = CreateThread(NULL,0,ThreadProc,0,0,&dwtid);
    return 0;
}

int Unload()
{
    TerminateThread(Thread,0);
    return 0;
}

int HandleMessage(char* message)
{
    if (StartsWith(message,"echo "))
    {

    }
    return 0;
}
